'+--------------------------------------------------------------------------+
'|                                 SPRITE                                   |
'|                                                                          |
'|            Example that shows you how to use the GDImage.dll             |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|                                                                          |
'|                           copyright (c) 2005                             |
'|                                                                          |
'|                Patrice Terrier http://www.zapsolution.com                |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 12-21-2005 (MM-DD-YYYY)            |
'|                        Last revised : 12-21-2005 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+

#COMPILE EXE "sprite.exe"

%MAX_SPRITE = 24

'-----------------------------------------------------------------
' Equates:  44
'-----------------------------------------------------------------
%WINAPI                                         = 1
%TRUE                                           = 1
%FALSE                                          = 0
%NULL                                           = 0
%MB_ICONHAND                                    = &H00000010&
%SWP_NOACTIVATE                                 = &H0010
%ERROR_ALREADY_EXISTS                           = 183&
%ANSI_VAR_FONT                                  = 12
%SW_HIDE                                        = 0
%SW_SHOW                                        = 5
%WS_EX_TRANSPARENT                              = &H00000020
%SW_RESTORE                                     = 9
%AW_HOR_POSITIVE                                = &H00000001
%AW_HOR_NEGATIVE                                = &H00000002
%AW_VER_POSITIVE                                = &H00000004
%AW_VER_NEGATIVE                                = &H00000008
%AW_CENTER                                      = &H00000010
%AW_SLIDE                                       = &H00040000
%AW_BLEND                                       = &H00080000
%AW_HIDE                                        = &H00010000
%AW_ACTIVATE                                    = &H00020000
%WM_CREATE                                      = &H1
%WM_DESTROY                                     = &H2
%WM_SIZE                                        = &H5
%WM_PAINT                                       = &HF
%WM_SETCURSOR                                   = &H20
%WM_MOUSEMOVE                                   = &H200
%WM_CLOSE                                       = &H10
%WM_ACTIVATE                                    = &H6
%WM_QUIT                                        = &H12
%WM_SETFONT                                     = &H30
%WM_COMMAND                                     = &H111
%WM_TIMER                                       = &H113
%WM_MOVING                                      = &H216
%WS_POPUP                                       = &H80000000
%WS_CHILD                                       = &H40000000
%WS_VISIBLE                                     = &H10000000
%WS_DISABLED                                    = &H08000000
%WS_CLIPSIBLINGS                                = &H04000000
%WS_CLIPCHILDREN                                = &H02000000
%WS_CAPTION                                     = &H00C00000  ' WS_BORDER OR WS_DLGFRAME
%WS_BORDER                                      = &H00800000
%WS_MINIMIZEBOX                                 = &H00020000
%WS_MAXIMIZEBOX                                 = &H00010000
%WS_SYSMENU                                     = &H00080000
%WS_TABSTOP                                     = &H00010000
%WS_EX_TOOLWINDOW                               = &H00000080
%WS_EX_WINDOWEDGE                               = &H00000100
%WS_EX_APPWINDOW                                = &H00040000
%CS_VREDRAW                                     = &H1
%CS_HREDRAW                                     = &H2
%PM_REMOVE                                      = &H0001
%SM_CXSCREEN                                    = 0
%SM_CYSCREEN                                    = 1
%IDC_ARROW                                      = 32512&
%SS_SUNKEN                                      = &H00001000
%SS_CENTER                                      = &H00000001

'-----------------------------------------------------------------
' TYPE and UNION structures:  6
'-----------------------------------------------------------------
TYPE RECT
  nLeft AS LONG
  nTop AS LONG
  nRight AS LONG
  nBottom AS LONG
END TYPE

TYPE POINTAPI
  x AS LONG
  y AS LONG
END TYPE

TYPE POINTS
  x AS INTEGER
  y AS INTEGER
END TYPE

TYPE tagMSG
  hwnd AS DWORD
  message AS DWORD
  wParam AS LONG
  lParam AS LONG
  time AS DWORD
  pt AS POINTAPI
END TYPE

TYPE SECURITY_ATTRIBUTES
  nLength AS DWORD
  lpSecurityDescriptor AS LONG
  bInheritHandle AS LONG
END TYPE

TYPE WNDCLASSEX
    cbSize AS DWORD
    style AS DWORD
    lpfnWndProc AS LONG
    cbClsExtra AS LONG
    cbWndExtra AS LONG
    hInstance AS DWORD
    hIcon AS DWORD
    hCursor AS DWORD
    hbrBackground AS DWORD
    lpszMenuName AS ASCIIZ PTR
    lpszClassName AS ASCIIZ PTR
    hIconSm AS DWORD
END TYPE

TYPE PAINTSTRUCT
  hDC AS DWORD
  fErase AS LONG
  rcPaint AS RECT
  fRestore AS LONG
  fIncUpdate AS LONG
  rgbReserved(0 TO 31) AS BYTE
END TYPE

'-----------------------------------------------------------------
' Declared Functions:  36
'-----------------------------------------------------------------
DECLARE FUNCTION DragDetect LIB "USER32.DLL" ALIAS "DragDetect" (BYVAL hWnd AS DWORD, pt AS POINTAPI) AS LONG
'DECLARE FUNCTION GetCursorPos LIB "USER32.DLL" ALIAS "GetCursorPos" (lpPoint AS POINTAPI) AS LONG
DECLARE FUNCTION GetMessagePos LIB "USER32.DLL" ALIAS "GetMessagePos" () AS LONG
DECLARE FUNCTION ScreenToClient LIB "USER32.DLL" ALIAS "ScreenToClient" (BYVAL hWnd AS DWORD, lpPoint AS POINTAPI) AS LONG
DECLARE FUNCTION GetDC LIB "USER32.DLL" ALIAS "GetDC" (BYVAL hWnd AS DWORD) AS DWORD
DECLARE FUNCTION ReleaseDC LIB "USER32.DLL" ALIAS "ReleaseDC" (BYVAL hWnd AS DWORD, BYVAL hDC AS DWORD) AS LONG
DECLARE FUNCTION GetTickCount LIB "KERNEL32.DLL" ALIAS "GetTickCount" () AS DWORD
DECLARE FUNCTION SetWindowPos LIB "USER32.DLL" ALIAS "SetWindowPos" (BYVAL hWnd AS DWORD, BYVAL hWndInsertAfter AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL cx AS LONG, BYVAL cy AS LONG, BYVAL wFlags AS DWORD) AS LONG
     DECLARE SUB apiSleep LIB "KERNEL32.DLL" ALIAS "Sleep" (BYVAL dwMilliseconds AS DWORD)
DECLARE FUNCTION AdjustWindowRectEx LIB "USER32.DLL" ALIAS "AdjustWindowRectEx" (lpRect AS RECT, BYVAL dsStyle AS LONG, BYVAL bMenu AS LONG, BYVAL dwEsStyle AS DWORD) AS LONG
DECLARE FUNCTION AnimateWindow LIB "USER32.DLL" ALIAS "AnimateWindow" (BYVAL hWnd AS DWORD, BYVAL dwTime AS DWORD, BYVAL dwFlags AS DWORD) AS LONG
DECLARE FUNCTION BeginPaint LIB "USER32.DLL" ALIAS "BeginPaint" (BYVAL hWnd AS DWORD, lpPaint AS PAINTSTRUCT) AS LONG
DECLARE FUNCTION SetCursor LIB "USER32.DLL" ALIAS "SetCursor" (BYVAL hCursor AS DWORD) AS DWORD
DECLARE FUNCTION CloseHandle LIB "KERNEL32.DLL" ALIAS "CloseHandle" (BYVAL hObject AS DWORD) AS LONG
DECLARE FUNCTION DeleteObject LIB "GDI32.DLL" ALIAS "DeleteObject" (BYVAL hObject AS DWORD) AS LONG
DECLARE FUNCTION CreateMutex LIB "KERNEL32.DLL" ALIAS "CreateMutexA" (lpMutexAttributes AS SECURITY_ATTRIBUTES, BYVAL bInitialOwner AS LONG, lpName AS ASCIIZ) AS LONG
DECLARE FUNCTION CreateWindowEx LIB "USER32.DLL" ALIAS "CreateWindowExA" (BYVAL dwExStyle AS DWORD, lpClassName AS ASCIIZ, lpWindowName AS ASCIIZ, BYVAL dwStyle AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG, _
    BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, BYVAL hWndParent AS DWORD, BYVAL hMenu AS DWORD, BYVAL hInstance AS DWORD, lpParam AS ANY) AS DWORD
DECLARE FUNCTION DefWindowProc LIB "USER32.DLL" ALIAS "DefWindowProcA" (BYVAL hWnd AS DWORD, BYVAL uMsg AS DWORD, BYVAL wParam AS DWORD, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION MessageBox LIB "USER32.DLL" ALIAS "MessageBoxA" (BYVAL hWnd AS DWORD, lpText AS ASCIIZ, lpCaption AS ASCIIZ, BYVAL dwType AS DWORD) AS LONG
DECLARE FUNCTION DispatchMessage LIB "USER32.DLL" ALIAS "DispatchMessageA" (lpMsg AS tagMSG) AS LONG
DECLARE FUNCTION EndPaint LIB "USER32.DLL" ALIAS "EndPaint" (BYVAL hWnd AS DWORD, lpPaint AS PAINTSTRUCT) AS LONG
DECLARE FUNCTION FindWindow LIB "USER32.DLL" ALIAS "FindWindowA" (lpClassName AS ASCIIZ, lpWindowName AS ASCIIZ) AS LONG
DECLARE FUNCTION GetParent LIB "USER32.DLL" ALIAS "GetParent" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION FreeLibrary LIB "KERNEL32.DLL" ALIAS "FreeLibrary" (BYVAL hLibModule AS DWORD) AS LONG
DECLARE FUNCTION GetClassInfoEx LIB "USER32.DLL" ALIAS "GetClassInfoExA" (BYVAL hInst AS DWORD, lpszClass AS ASCIIZ, lpWndClass AS WNDCLASSEX) AS LONG
DECLARE FUNCTION GetClientRect LIB "USER32.DLL" ALIAS "GetClientRect" (BYVAL hwnd AS DWORD, lpRect AS RECT) AS LONG
DECLARE FUNCTION GetDlgItem LIB "USER32.DLL" ALIAS "GetDlgItem" (BYVAL hDlg AS DWORD, BYVAL nIDDlgItem AS LONG) AS DWORD
DECLARE FUNCTION GetFocus LIB "USER32.DLL" ALIAS "GetFocus" () AS DWORD
DECLARE FUNCTION GetLastError LIB "KERNEL32.DLL" ALIAS "GetLastError" () AS LONG
DECLARE FUNCTION GetMessage LIB "USER32.DLL" ALIAS "GetMessageA" (lpMsg AS tagMSG, BYVAL hWnd AS DWORD, BYVAL uMsgFilterMin AS DWORD, BYVAL uMsgFilterMax AS DWORD) AS LONG
DECLARE FUNCTION GetProcAddress LIB "KERNEL32.DLL" ALIAS "GetProcAddress" (BYVAL hModule AS DWORD, lpProcName AS ASCIIZ) AS LONG
DECLARE FUNCTION GetStockObject LIB "GDI32.DLL" ALIAS "GetStockObject" (BYVAL nIndex AS LONG) AS DWORD
DECLARE FUNCTION GetSystemMetrics LIB "USER32.DLL" ALIAS "GetSystemMetrics" (BYVAL nIndex AS LONG) AS LONG
DECLARE FUNCTION GetWindowRect LIB "USER32.DLL" ALIAS "GetWindowRect" (BYVAL hWnd AS DWORD, lpRect AS RECT) AS LONG
DECLARE FUNCTION IsDialogMessage LIB "USER32.DLL" ALIAS "IsDialogMessageA" (BYVAL hDlg AS DWORD, lpMsg AS tagMSG) AS LONG
DECLARE FUNCTION IsIconic LIB "USER32.DLL" ALIAS "IsIconic" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION IsWindowVisible LIB "USER32.DLL" ALIAS "IsWindowVisible" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION LoadCursor LIB "USER32.DLL" ALIAS "LoadCursorA" (BYVAL hInstance AS DWORD, lpCursorName AS ASCIIZ) AS DWORD
DECLARE FUNCTION LoadIcon LIB "USER32.DLL" ALIAS "LoadIconA" (BYVAL hInstance AS DWORD, lpIconName AS ASCIIZ) AS DWORD
DECLARE FUNCTION LoadLibrary LIB "KERNEL32.DLL" ALIAS "LoadLibraryA" (lpLibFileName AS ASCIIZ) AS LONG
DECLARE FUNCTION MoveWindow LIB "USER32.DLL" ALIAS "MoveWindow" (BYVAL hWnd AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, BYVAL bRepaint AS LONG) AS LONG
DECLARE FUNCTION PeekMessage LIB "USER32.DLL" ALIAS "PeekMessageA" (lpMsg AS tagMSG, BYVAL hWnd AS DWORD, BYVAL dwMsgFilterMin AS DWORD, BYVAL dwMsgFilterMax AS DWORD, BYVAL dwRemoveMsg AS DWORD) AS LONG
DECLARE FUNCTION RegisterClassEx LIB "USER32.DLL" ALIAS "RegisterClassExA" (pcWndClassEx AS WNDCLASSEX) AS WORD
DECLARE FUNCTION SendMessage LIB "USER32.DLL" ALIAS "SendMessageA" (BYVAL hWnd AS DWORD, BYVAL dwMsg AS DWORD, BYVAL wParam AS DWORD, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION SetFocus LIB "USER32.DLL" ALIAS "SetFocus" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION SetForegroundWindow LIB "USER32.DLL" ALIAS "SetForegroundWindow" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION SetRect LIB "USER32.DLL" ALIAS "SetRect" (lpRect AS RECT, BYVAL X1 AS LONG, BYVAL Y1 AS LONG, BYVAL X2 AS LONG, BYVAL Y2 AS LONG) AS LONG
DECLARE FUNCTION ShowWindow LIB "USER32.DLL" ALIAS "ShowWindow" (BYVAL hWnd AS DWORD, BYVAL nCmdShow AS LONG) AS LONG
DECLARE FUNCTION TranslateMessage LIB "USER32.DLL" ALIAS "TranslateMessage" (lpMsg AS tagMSG) AS LONG
DECLARE FUNCTION SetWindowText LIB "USER32.DLL" ALIAS "SetWindowTextA" (BYVAL hWnd AS DWORD, lpString AS ASCIIZ) AS LONG
DECLARE FUNCTION GetWindowText LIB "USER32.DLL" ALIAS "GetWindowTextA" (BYVAL hWnd AS DWORD, lpString AS ASCIIZ, BYVAL cch AS LONG) AS LONG
DECLARE FUNCTION TimeGetTime LIB "WINMM.DLL" ALIAS "timeGetTime" () AS DWORD
DECLARE FUNCTION SetTimer LIB "USER32.DLL" ALIAS "SetTimer" (BYVAL hWnd AS DWORD, BYVAL nIDEvent AS LONG, BYVAL uElapse AS DWORD, BYVAL lpTimerFunc AS LONG) AS LONG
DECLARE FUNCTION KillTimer LIB "USER32.DLL" ALIAS "KillTimer" (BYVAL hWnd AS DWORD, BYVAL nIDEvent AS LONG) AS LONG

'-----------------------------------------------------------------
' Declared Subs:  2
'-----------------------------------------------------------------
DECLARE SUB InitCommonControls LIB "COMCTL32.DLL" ALIAS "InitCommonControls" ()
DECLARE SUB PostQuitMessage LIB "USER32.DLL" ALIAS "PostQuitMessage" (BYVAL nExitCode AS LONG)

'------------------------------------------------------------------------------------------
#RESOURCE "sprite.pbr"

'------------------------------------------------------------------------------------------
#INCLUDE "gdimage.inc"
DECLARE FUNCTION ZI_BoostSprite LIB "GDIMAGE.DLL" ALIAS "ZI_BoostSprite" (BYVAL nFlag AS LONG, BYVAL RW AS LONG) AS LONG
'------------------------------------------------------------------------------------------

%ID_CTRL         = 101
%ID_START_SHOW   = 102
%ID_STOP_SHOW    = 103
%ID_0            = 104
%ID_1            = 105
%ID_2            = 106
%ID_3            = 107
%ID_STATIC       = 108

' Warning each overlay object must have a unique identifier
%ID_OBJECT_SPRITE = 10

' WinXP Theme support declares (if applicable)
DECLARE FUNCTION EnableDialogTheme(BYVAL hDlg AS DWORD, BYVAL dwStyle AS DWORD) AS LONG
DECLARE FUNCTION IsThemeActive() AS LONG

GLOBAL ghMain, gnAnimate, gnFPS, gdwTT, gnCtrl, gnXY() AS LONG

FUNCTION zDefaultFont() AS LONG
    STATIC hDefault&
    IF hDefault& = 0 THEN hDefault& = GetStockObject(%ANSI_VAR_FONT)
    FUNCTION = hDefault&
END FUNCTION

SUB zSetCTLFont(BYVAL hC&, BYVAL hFont&)
    CALL SendMessage(hC&, %WM_SETFONT, hFont&, 0)
END SUB

FUNCTION zStaticCenter(BYVAL Label$, BYVAL x&, BYVAL y&, BYVAL w&, BYVAL h&, BYVAL hParent&, BYVAL ID&) AS LONG
    hCtl& = CreateWindowEx(0, "STATIC", (Label$), %WS_CHILD OR %WS_VISIBLE OR %SS_SUNKEN OR %SS_CENTER, _
                           x&, y&, w&, h&, hParent&, ID&, zInstance, BYVAL %NULL)
    CALL zSetCTLFont(hCtl&, zDefaultFont)
    FUNCTION = hCtl&
END FUNCTION

FUNCTION zGetCTLText(BYVAL hC&) AS STRING
    LOCAL szText AS ASCIIZ * 4096
    Length& = GetWindowText(hC&, szText, SIZEOF(szText))
    IF Length& THEN FUNCTION = LEFT$(szText, Length&)
END FUNCTION

FUNCTION zReportError(BYVAL Message$) AS LONG
    REPLACE $zLim WITH $CR IN Message$
    FUNCTION = MessageBox(0, (Message$), ("GDImage version " + ZI_Version), %MB_ICONHAND)
END FUNCTION

FUNCTION WinMain (BYVAL hInstance     AS LONG, _
                  BYVAL hPrevInstance AS LONG, _
                  BYVAL lpCmdLine     AS ASCIIZ PTR, _
                  BYVAL iCmdShow      AS LONG) AS LONG

    LOCAL Msg         AS tagMsg
    LOCAL wc          AS WndClassEx
    LOCAL zClass      AS ASCIIZ * 80
    LOCAL dwExStyle   AS DWORD
    LOCAL dwStyle     AS DWORD
    LOCAL rc          AS RECT
    LOCAL x           AS LONG
    LOCAL y           AS LONG
    LOCAL Done        AS LONG
    LOCAL hMutex      AS DWORD
    LOCAL hFound      AS DWORD
    LOCAL hBitmap     AS LONG
    LOCAL hImage      AS LONG
    LOCAL bmW         AS LONG
    LOCAL bmH         AS LONG
    LOCAL K           AS LONG
'
    LOCAl hWinXP_Lib           AS LONG ' Handle to WinXP Theme DLL
    LOCAL hWinXP_IsThemeActive AS LONG ' Handle to WinXP's IsThemeActive function
'
    zClass = "ZMAIN"
'
    hMutex = CreateMutex(BYVAL %Null, 0, zClass)
    IF hMutex THEN
       IF GetLastError = %ERROR_ALREADY_EXISTS THEN
          DO
             hFound = FindWindow(zClass, ""): IF hFound THEN EXIT DO
             WHILE PeekMessage(Msg, %NULL, %NULL, %NULL, %PM_REMOVE): WEND
          LOOP
          IF IsIconic(hFound) THEN CALL ShowWindow(hFound, %SW_RESTORE)
          CALL SetForeGroundWindow(hFound)
          FUNCTION = 0
          EXIT FUNCTION
       END IF
    END IF
'
    IsInitialized& = GetClassInfoEx(zInstance, zClass, wc)
    IF IsInitialized&   = 0 THEN
       wc.cbSize        = SIZEOF(wc)
       wc.style         = %CS_HREDRAW OR %CS_VREDRAW
       wc.lpfnWndProc   = CODEPTR(WndProc)
       wc.cbClsExtra    = 0
       wc.cbWndExtra    = 0
       wc.hInstance     = zInstance
       wc.hIcon         = LoadIcon(wc.hInstance, "PROGRAM")
       wc.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)
       wc.hbrBackground = 16 '%NULL ' GetStockObject(%BLACK_BRUSH)
       wc.lpszMenuName  = %NULL
       wc.lpszClassName = VARPTR(zClass)
       wc.hIconSm       = wc.hIcon
       IF RegisterClassEx(wc) THEN IsInitialized& = %TRUE
    END IF
'
    IF IsInitialized& THEN

     ' ************************************************************************************
     ' Load the GDImage.dll
       IF RegisterGDImageClass() = 0 THEN
          FUNCTION = 99:  EXIT FUNCTION ' If it fails to register then return ERROR = 99
       END IF
     ' ************************************************************************************

     ' Load the WinXP Theme support (if applicable)
       hWinXP_Lib = LoadLibrary("UxTheme.dll")
       IF hWinXP_Lib THEN
          hWinXP_IsThemeActive = GetProcAddress(hWinXP_Lib, "IsThemeActive")
       END IF
'
       CALL InitCommonControls
'
     ' Window Extended Style
       dwExStyle = %WS_EX_APPWINDOW OR %WS_EX_WINDOWEDGE
     ' Windows Style
       dwStyle = %WS_VISIBLE OR %WS_CLIPSIBLINGS OR %WS_CLIPCHILDREN OR %WS_CAPTION OR _
                 %WS_SYSMENU ' OR %WS_MAXIMIZEBOX OR %WS_MINIMIZEBOX
'
       CALL SetRect(rc, 0, 0, 800 + 136, 600)
       CALL AdjustWindowRectEx(rc, dwStyle, %FALSE, dwExStyle)  ' Adjust Window To True Requested Size
'
       x = MAX&((GetSystemMetrics(%SM_CXSCREEN) - rc.nRight - rc.nLeft) \ 2, 0)
       y = MAX&((GetSystemMetrics(%SM_CYSCREEN) - rc.nBottom - rc.nTop) \ 2, 0)
'
     ' Create The Window
       MyTitle$ = "GDImage control " + ZI_Version + " Demo with 24 Sprites 140 x 140"
       ghMain = CreateWindowEx(dwExStyle, _            ' Extended Style For The Window
                             zClass, _                ' Class Name
                             (MyTitle$), _            ' Window Title
                             dwStyle, _               ' Defined Window Style
                             x, y, _                  ' Window Position
                             rc.nRight - rc.nLeft, _  ' Calculate Window Width
                             rc.nBottom - rc.nTop, _  ' Calculate Window Height
                             %NULL, _                 ' No Parent Window
                             %NULL, _                 ' No Menu
                             wc.hInstance, _          ' Instance
                             BYVAL %NULL)             ' Dont Pass Anything To WM_CREATE
'
       IF ghMain THEN
'
        ' Apply WinXP Theme support
          LOCAL lRes AS LONG, pProc AS DWORD
          IF hWinXP_IsThemeActive THEN
             CALL DWORD hWinXP_IsThemeActive USING IsThemeActive TO lRes
             IF lRes  THEN pProc = GetProcAddress(lRes, "EnableThemeDialogTexture")
             IF pProc THEN CALL DWORD pProc USING EnableDialogTheme(ghMain, &H01 Or &H02 Or &H04 Or &H06)
          END IF
'
        ' Create button "START"
          CALL CreateWindowEx(0, "BUTTON", "START", %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP, _
                           807, 10, 120, 22, ghMain, %ID_START_SHOW, zInstance, BYVAL %NULL)
          CALL zSetCTLFont(GetDlgItem(ghMain, %ID_START_SHOW), zDefaultFont)

        ' Create button "STOP"
          CALL CreateWindowEx(0, "BUTTON", "STOP", %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP, _
                           807, 10 + (22 + 5) * 1, 120, 22, ghMain, %ID_STOP_SHOW, zInstance, BYVAL %NULL)
          CALL zSetCTLFont(GetDlgItem(ghMain, %ID_STOP_SHOW), zDefaultFont)


          CALL  CreateWindowEx(%WS_EX_TRANSPARENT, "Button", "GDImage TransBlt", %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP OR %BS_AUTORADIOBUTTON, _
                           807, 10 + (22 + 2) * 3, 120, 22, ghMain, %ID_1, zInstance, BYVAL %NULL)
          CALL zSetCTLFont(GetDlgItem(ghMain, %ID_1), zDefaultFont)
          CALL SendMessage(GetDlgItem(ghMain, %ID_1), &HF1, 1, 0)

          CALL  CreateWindowEx(%WS_EX_TRANSPARENT, "Button", "GDImage AlphaBlend", %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP OR %BS_AUTORADIOBUTTON, _
                           807, 10 + (22 + 2) * 4, 120, 22, ghMain, %ID_2, zInstance, BYVAL %NULL)
          CALL zSetCTLFont(GetDlgItem(ghMain, %ID_2), zDefaultFont)

          CALL  CreateWindowEx(%WS_EX_TRANSPARENT, "Button", "GDImage Composited", %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP OR %BS_AUTORADIOBUTTON, _
                           807, 10 + (22 + 2) * 5, 120, 22, ghMain, %ID_0, zInstance, BYVAL %NULL)
          CALL zSetCTLFont(GetDlgItem(ghMain, %ID_0), zDefaultFont)


        ' Create Static 
          CALL zStaticCenter("FPS ", 841, 410 - 18, 52, 18, ghMain, %ID_STATIC)

        ' ******************************************************************************
        ' Helper function to create A GDImage control (with automatic scrollbar support)
        ' ------------------------------------------------------------------------------
          gnCtrl = ZI_CreateWindow(ghMain, 0, 0, 800, 600, %ID_CTRL)
        ' Use gradient for background
          CALL ZI_SetProperty(gnCtrl, %ZI_GradientTop, RGB(93,3,28))
          CALL ZI_SetProperty(gnCtrl, %ZI_GradientBottom, RGB(0,3,40))

          CALL CreateSprite(ghMain)
'         // We want fastest speed animation, this means using only BMP file with magenta color!
          CALL ZI_BoostSprite(1,1)

        ' Show the main window
          CALL ShowWindow(ghMain, iCmdShow)
          CALL SetForegroundWindow(ghMain)                 ' Slightly Higher Priority
          CALL SetFocus(gnCtrl)                            ' Sets Keyboard Focus To The Window

'         //////////////////////////////////////////////////
'         // EXCLUSIVE LOOP
'          WHILE Done = %FALSE                              ' Loop That Runs While done = %FALSE
'             IF PeekMessage(Msg, %NULL, 0, 0, %PM_REMOVE) THEN ' Is There A Message Waiting?
'                IF msg.message = %WM_QUIT THEN             ' Have We Received A Quit Message?
'                   Done = %TRUE                            ' If So done = %TRUE
'                ELSE                                       ' If Not, Deal With Window Messages
'                   CALL TranslateMessage(msg)              ' Translate The Message
'                   CALL DispatchMessage(msg  )             ' Dispatch The Message
'                END IF
'             ELSE                                          ' If There Are No Messages
'              ' Draw The Scene.
'                IF gnAnimate THEN CALL DrawSprite          ' Render animation
'             END IF
'          WEND
'         //////////////////////////////////////////////////


'         //////////////////////////////////////////////////
'         // COOPERATIVE LOOP
          FOR K = 1 TO 1 ' Use 5 timers to get the same FPS than in exclusive mode
'              CALL SetTimer(ghMain, K, K - 1, %NULL)
              CALL SetTimer(ghMain, K, 5, %NULL)
          NEXT
          WHILE GetMessage(Msg, %NULL, 0, 0)
             CALL TranslateMessage(Msg)
             CALL DispatchMessage(Msg)
          WEND
          FOR K = 1 TO 1 '5
              CALL KillTimer(ghMain, K)
          NEXT
'         //////////////////////////////////////////////////

          FUNCTION = msg.wParam
       END IF

     ' UNLOAD the WinXP Theme DLL (if necessary)
       IF hWinXP_Lib THEN CALL FreeLibrary(hWinXP_Lib)

    END IF
'
    IF hMutex THEN CALL CloseHandle(hMutex)
'
END FUNCTION

SUB DrawSprite()
    REGISTER K AS LONG
    LOCAL X, Y AS LONG
    LOCAL rc AS RECT

    IF gnFPS = 0 THEN gdwTT = TimeGetTime() + 999

    FOR K = 1 TO %MAX_SPRITE

        X = (K MOD 8) + 1
        IF gnXY(K, 1) > 659 THEN
           gnXY(K, 3) = -1
        ELSEIF gnXY(K, 1) < 1 THEN
           gnXY(K, 3) = 1
        END IF
        X *= gnXY(K, 3): gnXY(K, 1) += X
        
        Y =(K MOD 10) + 1
        IF gnXY(K, 2) > 459 THEN
           gnXY(K, 4) = -1
        ELSEIF gnXY(K, 2) < 1 THEN
           gnXY(K, 4) = 1
        END IF
        Y *= gnXY(K, 4): gnXY(K, 2) += Y

        CALL ZD_SetObjectXY(%ID_OBJECT_SPRITE + K, gnXY(K, 1), gnXY(K, 2), %FALSE)

    NEXT

    CALL ZI_UpdateWindow(gnCtrl, 0): IF gdwTT THEN INCR gnFPS

    IF gdwTT THEN
       IF TimeGetTime() > gdwTT THEN
          CALL SetWindowText(GetDlgItem(ghMain, %ID_STATIC), _
                             EXTRACT$(zGetCTLText(GetDlgItem(ghMain, %ID_STATIC)), " ") + STR$(gnFPS))
          gdwTT = 0: gnFPS = 0
       END IF
    END IF

END SUB 

SUB CreateSprite(BYVAL hWin AS LONG)
    LOCAL rc AS RECT
    DIM gnXY(1 TO %MAX_SPRITE, 1 TO 4)

    CALL ZI_DisableAlphaCoef() '// Use this with zAlphaBlend, and if there is no rotation.
                               '// Note: this mode can't be changed on the fly.

    CALL GetClientRect(gnCtrl, rc)
    x& = (rc.nRight - bmW&) \ 2: y& = (rc.nBottom - bmH&) \ 2
    FOR K& = 1 TO %MAX_SPRITE
        IF K& = 1 THEN
           'CALL ZD_DrawBitmapToCtrl(gnCtrl, x&, y&, ZI_CreateBitmapFromFile("Hal_red.bmp", bmW&, bmH&), &HFFFFFFFF, %ID_OBJECT_SPRITE + K&, %FALSE): CALL ZI_TransparentColor(%ZD_TRANSCOLOR, 1)
           'CALL ZD_DrawBitmapToCtrl(gnCtrl, x&, y&, ZI_CreateBitmapFromFile("Red.png", bmW&, bmH&), &HFFFFFFFF, %ID_OBJECT_SPRITE + K&, %FALSE)
           CALL ZD_DrawBitmapToCtrl(gnCtrl, x&, y&, ZI_CreateBitmapFromFile("Brush.png", bmW&, bmH&), &HFFFFFFFF, %ID_OBJECT_SPRITE + K&, %FALSE)
        ELSE
           CALL ZD_CloneObject(%ID_OBJECT_SPRITE + 1, %ID_OBJECT_SPRITE + K&, x&, y&)
CALL ZD_SetObjectScale(%ID_OBJECT_SPRITE + 1, (10 * RND(5, 9)) / 100)
'CALL ZD_SetObjectAlpha(%ID_OBJECT_SPRITE + 1, RND(64,200), %FALSE)
        END IF
    NEXT

END SUB

FUNCTION WndProc(BYVAL hWin&, BYVAL Msg&, BYVAL wParam&, BYVAL lParam&) AS LONG
    LOCAL ps AS PAINTSTRUCT
    LOCAL lp AS POINTAPI

    SELECT CASE LONG Msg&

    CASE %WM_TIMER
         IF gnAnimate THEN CALL DrawSprite

    CASE %WM_COMMAND
         wP& = LOWRD(wParam&)

         SELECT CASE LONG wP&
         CASE %ID_START_SHOW
              FOR K& = 1 TO %MAX_SPRITE
                  CALL ZD_SetObjectVisibility(%ID_OBJECT_SPRITE + K&, %TRUE)
              NEXT
              gnAnimate = -1
  
         CASE %ID_STOP_SHOW
              gnAnimate = 0: gnFPS = 0
              CALL SetWindowText(GetDlgItem(hWin&, %ID_STATIC), EXTRACT$(zGetCTLText(GetDlgItem(hWin&, %ID_STATIC)), " "))
              FOR K& = 1 TO %MAX_SPRITE
                  CALL ZD_SetObjectVisibility(%ID_OBJECT_SPRITE + K&, %FALSE)
              NEXT

         CASE %ID_0: CALL ZI_BoostSprite(0,1)
         CASE %ID_1: CALL ZI_BoostSprite(1,1)
         CASE %ID_2: CALL ZI_BoostSprite(2,1)

         END SELECT

    CASE %WM_PAINT
         'CALL GradientPaint(hWin&, RGB(228,227,227), RGB(168,167,191))
         'FUNCTION = 0: EXIT FUNCTION

    CASE %WM_DESTROY
         CALL PostQuitMessage(0)
         FUNCTION = 0: EXIT FUNCTION
    END SELECT

    FUNCTION = DefWindowProc(hWin&, Msg&, wParam&, lParam&)

END FUNCTION

SUB GradientPaint(BYVAL hWin&, BYVAL TopRGB&, BYVAL BottomRGB&)
    LOCAL ps AS PAINTSTRUCT
    LOCAL rc AS RECT
  ' Tile the background
    CALL GetClientRect (hWin&, rc)
    hDC& = BeginPaint(hWin&, ps)
    CALL ZI_GradientPaintDC(hDC&, 0, 0, rc.nRight, rc.nBottom, TopRGB&, BottomRGB&)
    CALL EndPaint(hWin&, ps)
END SUB

